'use strict';

exports.__esModule = true;
exports.default = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

require('prismjs/themes/prism.css');

var _prismjs = require('prismjs');

var _prismjs2 = _interopRequireDefault(_prismjs);

require('prismjs/components/prism-markup-templating.js');

require('prismjs/components/prism-php.js');

require('prismjs/components/prism-sql.js');

require('prismjs/components/prism-smarty.js');

require('prismjs/components/prism-jsx.js');

require('prismjs/components/prism-bash.js');

require('prismjs/solidity');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// Custom module


var CodeOutputBlock = function (_React$Component) {
  _inherits(CodeOutputBlock, _React$Component);

  function CodeOutputBlock() {
    _classCallCheck(this, CodeOutputBlock);

    return _possibleConstructorReturn(this, _React$Component.apply(this, arguments));
  }

  CodeOutputBlock.prototype.componentDidMount = function componentDidMount() {
    if (!this.props.content) {
      this.props.onClick();
    }
  };

  CodeOutputBlock.prototype.render = function render() {

    var output;

    var _props = this.props,
        lang = _props.lang,
        content = _props.content,
        onClick = _props.onClick;


    var language = _prismjs2.default.languages[lang];

    if (typeof language == "undefined") {
      console.error("Unsupported language '" + lang + "'");
      lang = this.defaultLang;
    }

    if (content) {
      output = _prismjs2.default.highlight(content, language, lang);
    }

    return _react2.default.createElement('div', {
      className: 'text-content',
      dangerouslySetInnerHTML: { __html: output },
      onClick: onClick
    });
  };

  return CodeOutputBlock;
}(_react2.default.Component);

exports.default = CodeOutputBlock;
CodeOutputBlock.propTypes = process.env.NODE_ENV !== "production" ? {
  lang: _propTypes2.default.string.isRequired
} : {};
module.exports = exports['default'];