/**
 * Copyright (c) 2013-present, Facebook, Inc. All rights reserved.
 *
 * This file provided by Facebook is for non-commercial testing and evaluation
 * purposes only. Facebook reserves all rights not expressly granted.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
 * FACEBOOK BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

'use strict';

exports.__esModule = true;
exports.default = undefined;

var _class, _temp;

require('../../styles/less/styles.css');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _draftJs = require('draft-js');

var _draftJs2 = _interopRequireDefault(_draftJs);

var _immutable = require('immutable');

var _Button = require('material-ui/Button');

var _Button2 = _interopRequireDefault(_Button);

var _TextBlock = require('./TextBlock');

var _TextBlock2 = _interopRequireDefault(_TextBlock);

var _image = require('./blocks/image');

var _image2 = _interopRequireDefault(_image);

var _md = require('md5');

var _md2 = _interopRequireDefault(_md);

var _insertTextBlock = require('./modifiers/insertTextBlock');

var _removeTextBlock = require('./modifiers/removeTextBlock');

var _IconButton = require('material-ui/IconButton');

var _IconButton2 = _interopRequireDefault(_IconButton);

var _FormatBold = require('material-ui-icons/FormatBold');

var _FormatBold2 = _interopRequireDefault(_FormatBold);

var _FormatItalic = require('material-ui-icons/FormatItalic');

var _FormatItalic2 = _interopRequireDefault(_FormatItalic);

var _FormatUnderlined = require('material-ui-icons/FormatUnderlined');

var _FormatUnderlined2 = _interopRequireDefault(_FormatUnderlined);

var _Code = require('material-ui-icons/Code');

var _Code2 = _interopRequireDefault(_Code);

var _Send = require('material-ui-icons/Send');

var _Send2 = _interopRequireDefault(_Send);

var _HourglassEmpty = require('material-ui-icons/HourglassEmpty');

var _HourglassEmpty2 = _interopRequireDefault(_HourglassEmpty);

var _Create = require('material-ui-icons/Create');

var _Create2 = _interopRequireDefault(_Create);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }
// import removeRangeFromContentState from 'draft-js/lib/removeRangeFromContentState';


var Immutable = require('immutable');
var URI = require('fbjs/lib/URI');
// var DraftEntity = require('draft-js/lib/DraftEntity');

var Editor = _draftJs2.default.Editor,
    EditorState = _draftJs2.default.EditorState,
    RichUtils = _draftJs2.default.RichUtils,
    CompositeDecorator = _draftJs2.default.CompositeDecorator,
    convertToRaw = _draftJs2.default.convertToRaw,
    convertFromRaw = _draftJs2.default.convertFromRaw,
    ContentState = _draftJs2.default.ContentState,
    SelectionState = _draftJs2.default.SelectionState,
    Modifier = _draftJs2.default.Modifier,
    convertFromHTML = _draftJs2.default.convertFromHTML,
    genKey = _draftJs2.default.genKey,
    ContentBlock = _draftJs2.default.ContentBlock,
    getDefaultKeyBinding = _draftJs2.default.getDefaultKeyBinding;

// console.log('global.window', global.window);


// console.log('jsdom loaded', jsdom);


function Expander(props) {
  var expand = props.blockProps.expand;


  return _react2.default.createElement(
    'div',
    null,
    _react2.default.createElement(
      _Button2.default,
      {
        onClick: expand,
        accent: true,
        style: {
          textTransform: "none"
        }
      },
      '\u041F\u043E\u043A\u0430\u0437\u0430\u0442\u044C \u0441\u043A\u0440\u044B\u0442\u044B\u0439 \u043A\u043E\u043D\u0442\u0435\u043D\u0442'
    )
  );
}

var blockRenderMap = Immutable.Map({
  'image': {
    element: 'section'
  }
});

var extendedBlockRenderMap = _draftJs2.default.DefaultDraftBlockRenderMap.merge(blockRenderMap);

var styleMap = {
  CODE: {
    backgroundColor: 'rgba(0, 0, 0, 0.05)',
    fontFamily: '"Inconsolata", "Menlo", "Consolas", monospace',
    fontSize: 16,
    padding: 2
  }
};

var StyleButton = function (_React$Component) {
  _inherits(StyleButton, _React$Component);

  function StyleButton() {
    _classCallCheck(this, StyleButton);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this));

    _this.onToggle = function (e) {
      e.preventDefault();
      _this.props.onToggle(_this.props.style);
    };
    return _this;
  }

  StyleButton.prototype.render = function render() {
    // let className = 'RichEditor-styleButton';
    // if (this.props.active) {
    //   className += ' RichEditor-activeButton';
    // }

    var icon;

    switch (this.props.type) {
      case 'Bold':
        icon = _react2.default.createElement(_FormatBold2.default, null);
        break;

      case 'Italic':
        icon = _react2.default.createElement(_FormatItalic2.default, null);
        break;

      case 'Underlined':
        icon = _react2.default.createElement(_FormatUnderlined2.default, null);
        break;

      default:
        return null;
    }

    // tooltip={this.props.label}
    // tooltipPosition="bottom-center"
    // tooltipStyles={{
    //   top: 25
    // }}

    return _react2.default.createElement(
      _IconButton2.default,
      {
        key: 'Bold',
        onClick: this.onToggle,
        style: {
          height: 30,
          width: 30,
          padding: 0
        }
      },
      icon
    );
  };

  return StyleButton;
}(_react2.default.Component);

var INLINE_STYLES = [{ label: 'Жирный', type: 'Bold', style: 'BOLD' }, { label: 'Наклонный', type: 'Italic', style: 'ITALIC' }, { label: 'Подчеркнутый', type: 'Underlined', style: 'UNDERLINE' }];

var Controls = function Controls(props) {

  var currentStyle = props.editorState.getCurrentInlineStyle();

  var insertButton;

  return _react2.default.createElement(
    'div',
    { className: 'RichEditor-controls' },
    _react2.default.createElement(
      _IconButton2.default,
      {
        key: 'Bold',
        onClick: props.insertCodeBlock,
        style: {
          height: 30,
          width: 30,
          padding: 0
        }
      },
      _react2.default.createElement(_Code2.default, null)
    ),
    INLINE_STYLES.map(function (type) {
      return _react2.default.createElement(StyleButton, {
        key: type.label,
        active: currentStyle.has(type.style),
        label: type.label,
        type: type.type,
        onToggle: props.onToggle,
        style: type.style
      });
    })
  );
};

function findLinkEntities(contentBlock, callback, contentState) {
  contentBlock.findEntityRanges(function (character) {
    var entityKey = character.getEntity();
    return entityKey !== null && contentState.getEntity(entityKey).getType() === 'LINK';
  }, callback);
}

var Link = function Link(props) {
  var _props$contentState$g = props.contentState.getEntity(props.entityKey).getData(),
      url = _props$contentState$g.url;

  return _react2.default.createElement(
    'a',
    { href: url, rel: 'nofollow', target: '_blank' },
    props.children
  );
};

var decorator = new CompositeDecorator([{
  strategy: findLinkEntities,
  component: Link
}]);

/**
 * Если передана функция onChange, 
 * при обновлении будет формироваться rawContent.
 * 
 * При вызове Send() возвращается rawContent
 */

var TextEditor = (_temp = _class = function (_React$Component2) {
  _inherits(TextEditor, _React$Component2);

  function TextEditor(props) {
    _classCallCheck(this, TextEditor);

    // console.log("TextEditor constructor", props);

    var _this2 = _possibleConstructorReturn(this, _React$Component2.call(this, props));

    _this2.handleDroppedFiles = function (selection, files) {
      // console.log('handleDroppedFiles', selection, files);
    };

    _this2.handleDrop = function (selection, files) {
      // console.log('handleDrop', selection, files);
    };

    var setFullView = _this2.props.setFullView;


    var editorState = _this2.initEditState(props.content);

    _this2.state = {
      editorState: editorState,
      // editorState: EditorState.createEmpty(decorator),
      liveTeXEdits: (0, _immutable.Map)(),
      id: props.id,
      readonly: !props.allow_edit,
      // update: false,
      target_id: props.target_id || null,
      // fullView: props.fullView,
      inEditMode: props.inEditMode || false,
      allow_edit: props.allow_edit || false,
      clearOnSave: props.clearOnSave || false,
      images: [],
      isDirty: false,
      lastModified: null,
      errors: {},
      // show_message: "",
      sending: false
    };

    _this2._blockRenderer = function (block) {
      if (block.getType() === 'atomic') {

        if (_this2.props.fullView !== true && _this2.state.inEditMode !== true) {

          return {
            component: Expander,
            props: {
              expand: setFullView
            }
          };
        }

        return {
          component: _TextBlock2.default,
          editable: false,
          props: {
            allow_edit: _this2.state.inEditMode,
            _insertText: _this2._insertText,
            fullView: _this2.props.fullView === true || _this2.state.inEditMode === true,
            onStartEdit: function onStartEdit(blockKey) {
              // alert('onStartEdit');
              var liveTeXEdits = _this2.state.liveTeXEdits;

              _this2.setState({ liveTeXEdits: liveTeXEdits.set(blockKey, true) });
            },
            onFinishEdit: function onFinishEdit(blockKey, newContentState) {
              // alert('onFinishEdit');
              var liveTeXEdits = _this2.state.liveTeXEdits;


              var editorState = EditorState.createWithContent(newContentState);

              EditorState.set(editorState, { decorator: decorator });

              _this2.setState({
                liveTeXEdits: liveTeXEdits.remove(blockKey),
                editorState: editorState
              });
            },
            onRemove: function onRemove(blockKey) {
              return _this2._removeTeX(blockKey);
            }
          }
        };
      } else if (block.getType() === 'image') {

        if (_this2.props.fullView !== true && _this2.state.inEditMode !== true) {

          return {
            component: Expander,
            props: {
              expand: setFullView
            }
          };
        }

        return {
          component: _image2.default,
          editable: false,
          props: {}
        };
      }
      return null;
    };

    _this2._onChange = function (editorState) {

      _this2.setState({
        editorState: editorState
      });

      var onChange = _this2.props.onChange;


      if (onChange) {

        var currentContent = editorState.getCurrentContent();

        return onChange(editorState, convertToRaw(currentContent));
      }
    };

    _this2._handleKeyCommand = function (command) {
      var editorState = _this2.state.editorState;

      var newState = RichUtils.handleKeyCommand(editorState, command);

      if (newState) {
        // newState.isDirty = true;
        _this2._onChange(newState);
        return true;
      }
      return false;
    };

    _this2._removeTeX = function (blockKey) {
      var _this2$state = _this2.state,
          editorState = _this2$state.editorState,
          liveTeXEdits = _this2$state.liveTeXEdits;

      _this2.setState({
        liveTeXEdits: liveTeXEdits.remove(blockKey),
        editorState: (0, _removeTextBlock.removeTextBlock)(editorState, blockKey)
      });
    };

    _this2._insertText = function () {
      _this2.setState({
        liveTeXEdits: (0, _immutable.Map)(),
        editorState: (0, _insertTextBlock.insertTextBlock)(_this2.state.editorState)
      });
    };

    _this2.toggleInlineStyle = function (style) {
      return _this2._toggleInlineStyle(style);
    };
    return _this2;
  }

  TextEditor.prototype.initEditState = function initEditState(content) {
    var editorState;

    var state = null;

    if (content && typeof content == "string") {

      /*
      * Пытаемся распарсить JSON
      * */
      try {
        var json = JSON.parse(content);

        if (json) {
          content = json;
        }
      } catch (e) {}

      if (!content.blocks) {
        // if(typeof window != "undefined"){
        // }

        if (typeof window != "undefined") {
          var blocks = convertFromHTML(content);
          state = ContentState.createFromBlockArray(blocks);
        }

        /*
          В роутере server-side прописана функция виртуализации DOM.
          https://github.com/facebook/draft-js/issues/586#issuecomment-300347678
        */
        else if (global.serverDOMBuilder) {

            var _blocks = convertFromHTML(content, global.serverDOMBuilder);
            // const blocks = global.serverDOMBuilder(content, convertFromHTML);

            state = ContentState.createFromBlockArray(_blocks);
          }
      }
    }

    if (!state && content && content.blocks) {
      state = convertFromRaw(content);
    }

    if (state) {
      editorState = EditorState.createWithContent(state);
    } else {
      editorState = EditorState.createEmpty();
    }

    return EditorState.set(editorState, { decorator: decorator });

    // editorState = EditorState.createEmpty(); 

    // return editorState;
  };

  TextEditor.prototype.clearError = function clearError() {
    this.setState({
      errors: {}
    });
  };

  /*
   * Пытаемся получить картинку по ссылке
   * */


  TextEditor.prototype.parseImageLink = function parseImageLink(block_id, text) {
    var _this3 = this;

    var match = text.matchAll(/((^| |\.)https?\:\/\/.+?\/.+?)( |$|\n|\t|\r)/gi);

    if (match) {

      var result;

      var _loop = function _loop() {

        if (!result.value || result.done == true) {
          return 'break';
        }

        url = result.value[1];

        var scope = _this3;

        if (url != '') {

          fetch('/api/get_image_meta/?url=' + url, {
            method: "GET"
          }).then(function (response) {
            return response.json();
          }).then(function (data) {
            // console.log('parseImageLink data', data);

            if (!data) {
              return;
            }

            /*
            * Если УРЛ был получен,
            * разбиваем текущий текстовый блок
            * */
            if (data.success && data.url) {
              var _editorState = scope.state.editorState;


              var newBlockType = 'image';

              var initialData = {
                original_url: url,
                url: data.url
              };

              var selection = _editorState.getSelection();
              // let block_id = selection.getAnchorKey();
              var content = _editorState.getCurrentContent();
              var blockMap = content.getBlockMap();
              var block = blockMap.get(block_id);
              var blocksBefore = blockMap.toSeq().takeUntil(function (v) {
                return v === block;
              });
              var blocksAfter = blockMap.toSeq().skipUntil(function (v) {
                return v === block;
              }).rest();
              var newBlockKey = genKey();

              var text = "";
              var characterList = (0, _immutable.List)();
              characterList.size = text.length;

              var newBlock = new ContentBlock({
                key: newBlockKey,
                type: newBlockType,
                text: text,
                characterList: characterList,
                // characterList: block.getCharacterList().slice(0, 0),
                // depth: 0,
                data: (0, _immutable.Map)(initialData)
              });

              var newBlockMap = blocksBefore.concat([[block_id, block], [newBlockKey, newBlock]], blocksAfter).toOrderedMap();

              var newContent = content.merge({
                blockMap: newBlockMap,
                selectionBefore: selection,
                selectionAfter: selection.merge({
                  anchorKey: newBlockKey,
                  anchorOffset: 0,
                  focusKey: newBlockKey,
                  focusOffset: 0,
                  isBackward: false
                })
              });

              var _editorState = EditorState.push(_editorState, newContent, 'split-block');

              scope._onChange(_editorState);
            }
          }.bind(_this3)).catch(function (error) {
            console.error('Request failed', error);
          });

          images = _this3.state.images;


          _this3.setState({});
        }
      };

      while (result = match.next()) {
        var url;
        var images;

        var _ret = _loop();

        if (_ret === 'break') break;
      }
    }

    // Пытаемся найти все ссылки.
  };

  TextEditor.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {

    var newState = {
      hash: new Date().getTime()
    };

    if (this.state.allow_edit != nextProps.allow_edit) {
      newState.allow_edit = nextProps.allow_edit;
    }

    if (this.state.target_id != nextProps.target_id) {
      newState.target_id = nextProps.target_id;
    }

    if (this.state.id != nextProps.id) {
      newState.id = nextProps.id;
    }

    if ((this.props.inEditMode || nextProps.inEditMode) && this.props.inEditMode != nextProps.inEditMode) {
      newState.inEditMode = nextProps.inEditMode;
    }

    if (this.state.tags != nextProps.tags && this.state.tags && nextProps.tags && (0, _md2.default)(this.state.tags) != (0, _md2.default)(nextProps.tags)) {
      newState.tags = nextProps.tags;
    }

    this.setState(newState);
    // if(md5(nextProps.content) != md5())

    return true;
  };

  TextEditor.prototype._toggleInlineStyle = function _toggleInlineStyle(inlineStyle) {
    this._onChange(RichUtils.toggleInlineStyle(this.state.editorState, inlineStyle));
  };

  TextEditor.prototype.getAction = function getAction() {
    return !this.state.id ? 'chat/postmessage' : 'chat/message/update';
  };

  TextEditor.prototype.prepareRequestData = function prepareRequestData(data) {
    return data;
  };

  TextEditor.prototype.editMessage = function editMessage() {

    this.setState({
      inEditMode: true
    });

    this._onChange(this.state.editorState);
  };

  TextEditor.prototype._handlePastedText = function _handlePastedText(text, html) {

    window.text = text;
    /*
     * Обновляем контент, ищем ссылки на картинки
     * */
    var editorState = this.state.editorState;

    var selection = editorState.getSelection();
    var currentBlockKey = selection.getAnchorKey();

    if (currentBlockKey) {
      var currentBlock = editorState.getCurrentContent().getBlockForKey(currentBlockKey);

      if (currentBlock.type == "unstyled") {

        if (!html) {

          if (!text || text == '') {
            return;
          }

          // if(!(/^https?:\/\/.+$/u.test(text))){
          //   return;
          // }
          /*
          * http://modxclub.local/ sdfdsf
          *
          * http://modxclub.local/
          * sdfdsf
          * */

          if (!new RegExp("^https?\:\/\/[^ ]+$", "uim").test(text.replace(/[\n\r]/, ' '))) {
            return;
          }

          var _editorState2 = this.state.editorState;

          var _selection = _editorState2.getSelection();
          var contentState = _editorState2.getCurrentContent();

          var length = text.length;
          var startSelection = _selection.getEndOffset();
          var endSelection = startSelection + length;

          if (_selection.isCollapsed()) {
            var cs = Modifier.insertText(_editorState2.getCurrentContent(), _selection, text);

            var newEditorState = EditorState.push(_editorState2, cs, 'insert-text');

            var contentStateWithEntity = newEditorState.getCurrentContent().createEntity('LINK', 'MUTABLE', { url: text });
            var entityKey = contentStateWithEntity.getLastCreatedEntityKey();

            var newEditorState = EditorState.set(newEditorState, { currentContent: contentStateWithEntity });

            // var linked = Modifier.applyEntity(newEditorState.getCurrentContent(), newEditorState.getSelection(), entityKey);
            var linked = Modifier.applyEntity(newEditorState.getCurrentContent(), _selection.merge({
              anchorOffset: startSelection,
              focusOffset: endSelection
              // anchorOffset: selection.getEndOffset(),
              // focusOffset: selection.getEndOffset()
            }), entityKey);

            var newEditorState = EditorState.push(newEditorState, linked, 'apply-entity');

            var collapsed = _selection.merge({
              // anchorOffset: 0,
              // focusOffset: 22,
              anchorOffset: newEditorState.getSelection().getEndOffset(),
              focusOffset: newEditorState.getSelection().getEndOffset()
            });
            var newEditorState = EditorState.forceSelection(newEditorState, collapsed);

            var cs = Modifier.insertText(newEditorState.getCurrentContent(), newEditorState.getSelection(), " ");

            // console.log('cs', cs);

            var newEditorState = EditorState.push(newEditorState, cs, 'insert-text');

            this.setState({
              editorState: newEditorState
            }, function () {
              // setTimeout(() => this.refs.editor.focus(), 0);
            });

            // this.setState({
            //   editorState: newEditorState,
            // });

            this.parseImageLink(currentBlockKey, text);
            return 'handled';
          }
        }
      }
    }
  };

  TextEditor.prototype.componentWillUpdate = function componentWillUpdate(nextProps, nextState) {

    // console.log('componentWillUpdate', nextProps, this.props);
    // console.log('componentWillUpdate', nextState, this.state);

    /*
     * Скрываем/раскрываем допблоки контента
     * */
    if (nextProps.fullView != this.props.fullView || nextState.inEditMode != this.state.inEditMode) {
      // console.log('componentDidUpdate 3');
      // this.setState({
      // });

      this.setState(function (prevState) {

        var newState = prevState;

        newState.editorState = prevState.editorState;

        var newEditorState = EditorState.forceSelection(newState.editorState, newState.editorState.getSelection());

        newState.editorState = newEditorState;

        return newState;
      });
    }
  };

  TextEditor.prototype.componentDidUpdate = function componentDidUpdate(prevProps, prevState) {};

  TextEditor.prototype.getTags = function getTags() {
    return null;
  };

  TextEditor.prototype.keyBindingFn = function keyBindingFn(e) {

    // console.log('keyBindingFn', e);
    // console.log('keyBindingFn ctrlKey', e.ctrlKey);
    // console.log('keyBindingFn keyCode', e.keyCode);

    if (e.ctrlKey && e.keyCode == 13) {
      this.Send(e);
      return;
    }

    // if (e.keyCode === 83 /* `S` key */ && hasCommandModifier(e)) {
    //   return 'myeditor-save';
    // }
    return getDefaultKeyBinding(e);
  };

  TextEditor.prototype.Send = function Send(event) {
    var Send = this.props.Send;
    var editorState = this.state.editorState;


    var currentContent = editorState && editorState.getCurrentContent();

    return Send && Send(event, currentContent && convertToRaw(currentContent) || null) || false;
  };

  /**
   * While editing TeX, set the Draft editor to read-only. This allows us to
   * have a textarea within the DOM.
   */


  TextEditor.prototype.render = function render() {
    var _this4 = this;

    var sendButton, editButton;

    // if (this.state.allow_edit) {
    //   if (this.state.inEditMode) {
    //     sendButton = <IconButton
    //       onClick={event => this.Send(event)}>
    //       {this.state.sending !== true
    //         ?
    //         <Send
    //           color={this.state.isDirty === true ? 'red' : '#8080FF'}
    //         />
    //         :
    //         <WaitIcon
    //           color="grey"
    //         />
    //       }

    //     </IconButton>;
    //   }
    //   else {
    //     editButton = <IconButton
    //       onClick={this.editMessage.bind(this)}>
    //       <Create />
    //     </IconButton>;
    //   }
    // }

    var editorState = this.state.editorState;


    var controls;

    if (this.state.allow_edit && this.state.inEditMode) {
      controls = _react2.default.createElement(Controls, {
        editorState: editorState,
        onToggle: this.toggleInlineStyle,
        insertCodeBlock: this._insertText
      });
    }

    return _react2.default.createElement(
      'div',
      { className: "CommentEditorWrapper " + this.props.className },
      controls,
      _react2.default.createElement(
        'div',
        { className: "Editor-container" + (this.state.inEditMode && this.state.allow_edit ? ' edit' : ''), style: { height: '100%', boxSizing: 'border-box' } },
        _react2.default.createElement(
          'div',
          { className: 'Editor-root', style: { width: "calc(100% - 48px)", boxSizing: 'border-box' } },
          _react2.default.createElement(
            'div',
            { className: 'Editor-editor', style: {
                alignItems: 'center',
                minHeight: '30px',
                color: 'rgba(0, 0, 0, 0.87)',
                fontSize: '15px',
                fontWeight: '500',
                boxSizing: 'border-box'
              } },
            _react2.default.createElement(Editor, {
              editorState: editorState,
              blockRendererFn: this._blockRenderer,
              blockRenderMap: extendedBlockRenderMap,
              handleKeyCommand: this._handleKeyCommand,
              handlePastedText: this._handlePastedText.bind(this),
              handleDroppedFiles: this.handleDroppedFiles,
              handleDrop: this.handleDrop,
              onChange: this._onChange,
              onTab: this.onTab,
              customStyleMap: styleMap,
              placeholder: '',
              spellCheck: true,
              readOnly: !this.state.inEditMode || this.state.readonly || this.state.liveTeXEdits.count(),
              keyBindingFn: function keyBindingFn(e) {
                return _this4.keyBindingFn(e);
              }
            })
          )
        ),
        _react2.default.createElement(
          'div',
          { className: 'send-button__wrapper' },
          sendButton,
          editButton
        )
      ),
      this.getTags()
    );
  };

  return TextEditor;
}(_react2.default.Component), _class.contextTypes = {}, _class.defaultProps = {
  fullView: true
}, _temp);
exports.default = TextEditor;
TextEditor.propTypes = process.env.NODE_ENV !== "production" ? {
  onChange: _propTypes2.default.func,
  Send: _propTypes2.default.func
} : {};
module.exports = exports['default'];