'use strict';

exports.__esModule = true;
exports.default = undefined;

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _index = require('./index');

var _index2 = _interopRequireDefault(_index);

var _Chip = require('material-ui/Chip');

var _Chip2 = _interopRequireDefault(_Chip);

var _AutoComplete = require('../AutoComplete');

var _AutoComplete2 = _interopRequireDefault(_AutoComplete);

var _reactRouterDom = require('react-router-dom');

var _const = require('../const/');

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var propTypes = _index2.default.propTypes && _lodash2.default.cloneDeep(_index2.default.propTypes) || {};

Object.assign(propTypes, {
  setFullView: _propTypes2.default.func.isRequired
});

var TopicEditor = (_temp = _class = function (_TextEditor) {
  _inherits(TopicEditor, _TextEditor);

  function TopicEditor(props) {
    _classCallCheck(this, TopicEditor);

    // console.log("this.state", this.state);

    var _this = _possibleConstructorReturn(this, _TextEditor.call(this, props));

    _this.handleRequestDelete = function (key) {
      // console.log('key', key);

      // if (key === 3) {
      //   alert('Why would you want to delete React?! :)');
      //   return;
      // }
      //
      // this.chipData = this.state.chipData;
      // const chipToDelete = this.chipData.map((chip) => chip.key).indexOf(key);
      // this.chipData.splice(chipToDelete, 1);
      // this.setState({chipData: this.chipData});

      _this.setState(function (prevState) {
        var tags = prevState.tags;

        if (tags.length) {
          var i = 0;

          tags.map(function (item) {

            if (item === key) {
              tags.splice(i, 1);
              i--;

              return false;
            }

            i++;
          });
        }

        return {
          tags: tags
        };
      });
    };

    _this.state.document = props.document;
    _this.state.tags = props.document.topic_tags || [];
    _this.state.validTags = props.validTags || [];

    return _this;
  }

  TopicEditor.prototype.getAction = function getAction() {
    return !this.state.id ? 'topics/create' : 'topics/update';
  };

  TopicEditor.prototype.componentDidUpdate = function componentDidUpdate(prevProps, prevState) {
    if (this.state.inEditMode === true && prevState.inEditMode != this.state.inEditMode) {
      this.loadTags();
    }

    return true;
  };

  TopicEditor.prototype.componentDidMount = function componentDidMount() {
    if (this.state.inEditMode === true) {
      this.loadTags();
    }
  };

  TopicEditor.prototype.prepareRequestData = function prepareRequestData(data) {
    // alert(data);

    Object.assign(data, {
      content: data.text,
      pagetitle: this.props.pagetitle,
      topic_tags: this.state.tags
    });

    // console.log('prepareRequestData', data);

    return data;
  };

  TopicEditor.prototype.getTags = function getTags() {
    var _this3 = this;

    var tags = [];

    if (this.state.tags && this.state.tags.length) {
      this.state.tags.map(function (tag) {
        var _this2 = this;

        tags.push(_react2.default.createElement(
          _reactRouterDom.Link,
          {
            key: tag,
            to: '/tag/' + tag,
            href: '/tag/' + tag,
            className: 'underline-none'
          },
          _react2.default.createElement(_Chip2.default, {
            label: tag,
            style: {
              margin: 3
            },
            className: 'link',
            onRequestDelete: this.state.inEditMode === true ? function () {
              return _this2.handleRequestDelete(tag);
            } : null
          })
        ));
      }, this);
    }

    var dataSource = [];

    this.state.validTags.map(function (item) {
      dataSource.push(item);
    });

    dataSource.push(this.state.raw_tag);

    return tags.length || this.state.inEditMode === true ? _react2.default.createElement(
      'div',
      null,
      this.state.inEditMode === true ? _react2.default.createElement(_AutoComplete2.default, {
        label: '\u0423\u043A\u0430\u0436\u0438\u0442\u0435 \u0442\u0435\u0433\u0438',
        error: this.state.errors.topic_tags && this.state.errors.topic_tags != "",
        onFocus: function onFocus() {
          _this3.clearError();
        },
        filter: _AutoComplete2.default.caseInsensitiveFilter,
        maxSearchResults: 10,
        searchText: this.state.searchText,
        dataSource: dataSource,
        onNewRequest: function onNewRequest(value) {
          _this3.setState(function (prevState) {

            var tags = prevState.tags || [];

            tags.push(value);

            return {
              tags: tags,
              test: value,
              searchText: ""
            };
          });
        },
        onUpdateInput: function onUpdateInput(value) {
          console.log('onUpdateInput', value);
          _this3.setState({
            raw_tag: value,
            searchText: value
          });
        }
      }) : null,
      _react2.default.createElement(
        'div',
        { style: {
            display: 'flex',
            flexWrap: 'wrap'
          } },
        tags
      )
    ) : null;
  };

  TopicEditor.prototype.loadTags = function loadTags() {
    if (!this.state.validTags || !this.state.validTags.length) {
      var body = new FormData();

      var data = {
        format: "json",
        limit: 0
      };

      for (var i in data) {
        var value = data[i];

        body.append(i, value);
      };

      this.setState({});

      fetch(_const.CONNECTOR_URL + '?pub_action=tags/getdata', {
        credentials: 'same-origin',
        method: "POST",
        body: body
      }).then(function (response) {

        return response.json();
      }).then(function (data) {

        if (data.success == true && data.object) {

          var tags = [];

          data.object.map(function (item) {
            tags.push(item.tag);
          });

          var newState = {
            validTags: tags
          };
          this.setState(newState);
        } else {
          console.error(data.message || "Ошибка выполнения запроса");
        }
      }.bind(this)).catch(function (error) {
        console.error('Request failed', error);
      });
    }
  };

  return TopicEditor;
}(_index2.default), _class.propTypes = propTypes, _temp);
exports.default = TopicEditor;
module.exports = exports['default'];