'use strict';

exports.__esModule = true;
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp, _class2, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _front = require('@prisma-cms/front');

var _front2 = _interopRequireDefault(_front);

var _api = require('@prisma-cms/front/lib/schema/generated/api.fragments');

var queryFragments = _interopRequireWildcard(_api);

var _App = require('../App');

var _App2 = _interopRequireDefault(_App);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DevRenderer = (_temp = _class = function (_PrismaCmsRenderer) {
  _inherits(DevRenderer, _PrismaCmsRenderer);

  function DevRenderer() {
    _classCallCheck(this, DevRenderer);

    return _possibleConstructorReturn(this, _PrismaCmsRenderer.apply(this, arguments));
  }

  DevRenderer.prototype.getRoutes = function getRoutes() {
    var _this2 = this;

    return [{
      exact: true,
      path: "/",
      component: _App2.default
    }, {
      path: "*",
      render: function render(props) {
        return _this2.renderOtherPages(props);
      }
    }];
  };

  DevRenderer.prototype.render = function render() {
    var _this3 = this;

    var _props = this.props,
        pure = _props.pure,
        other = _objectWithoutProperties(_props, ['pure']);

    var rawContent = this.state.rawContent;


    return _react2.default.createElement(
      'div',
      null,
      pure ? _react2.default.createElement(_App2.default, _extends({
        content: '<p>Test content</p>',
        allow_edit: true,
        inEditMode: true,
        onChange: function onChange(state, rawContent) {
          // console.log("onChange newState", state);
          // console.log("onChange rawContent", rawContent);
          _this3.setState({
            rawContent: rawContent
          });
        },
        Send: function Send(event) {
          console.log("Send", event);
        }
      }, other)) : _PrismaCmsRenderer.prototype.render.call(this),
      _react2.default.createElement(
        'div',
        null,
        JSON.stringify(rawContent)
      )
    );
  };

  return DevRenderer;
}(_front.Renderer), _class.propTypes = _extends({}, _front.Renderer.propTypes, {
  pure: _propTypes2.default.bool.isRequired
}), _class.defaultProps = _extends({}, _front.Renderer.defaultProps, {
  pure: true
}), _temp);
var DevApp = (_temp2 = _class2 = function (_Component) {
  _inherits(DevApp, _Component);

  function DevApp() {
    _classCallCheck(this, DevApp);

    return _possibleConstructorReturn(this, _Component.apply(this, arguments));
  }

  DevApp.prototype.render = function render() {
    var _props2 = this.props,
        queryFragments = _props2.queryFragments,
        other = _objectWithoutProperties(_props2, ['queryFragments']);

    return _react2.default.createElement(_front2.default, _extends({
      queryFragments: queryFragments,
      Renderer: DevRenderer
      // pure={true}
    }, other));
  };

  return DevApp;
}(_react.Component), _class2.defaultProps = {
  queryFragments: queryFragments,
  lang: "ru"
}, _temp2);
exports.default = DevApp;
DevApp.propTypes = process.env.NODE_ENV !== "production" ? {
  queryFragments: _propTypes2.default.object.isRequired
} : {};
module.exports = exports['default'];