'use strict';

var _require = require('jsdom'),
    JSDOM = _require.JSDOM;

var Node = require('jsdom/lib/jsdom/living/node-document-position');

// We can use jsdom-global at some point if maintaining these lists is a burden.
var whitelist = ['HTMLElement', 'Performance'];
var blacklist = ['sessionStorage', 'localStorage'];

function createDOM() {
  var dom = new JSDOM('', { pretendToBeVisual: true });
  global.window = dom.window;
  global.Node = Node;
  global.document = dom.window.document;
  // Not yet supported: https://github.com/jsdom/jsdom/issues/317
  global.document.createRange = function () {
    return {
      setStart: function setStart() {},
      setEnd: function setEnd() {},
      commonAncestorContainer: {
        nodeName: 'BODY',
        ownerDocument: document
      }
    };
  };
  global.navigator = {
    userAgent: 'node.js'
  };

  Object.keys(dom.window).filter(function (key) {
    return !blacklist.includes(key);
  }).concat(whitelist).forEach(function (key) {
    if (typeof global[key] === 'undefined') {
      global[key] = dom.window[key];
    }
  });
}

module.exports = createDOM;

it("", function () {

  return;
});